package io.zipcoder.casino;
import java.util.ArrayList;
import java.util.Arrays;
public class Baccarat extends CardGame {
    private ArrayList<Card> playerHand = new ArrayList<Card>();
    private ArrayList<Card> dealerHand = new ArrayList<Card>();
    private int currentBet;
    private CardDeck deck;
    private Player player;
    private boolean playingBaccarat = false;
    public Baccarat(Player player) {
        this.player = player;
        this.deck = new CardDeck();
    }
    public void start() {
        playingBaccarat = true;
        this.deck.shuffle();
    }
    public void bet(int amount) { currentBet = amount; }
    public void loseBet(int currentBet){ player.subtractFromBankroll(currentBet);}
    public void winBet(int currentBet) { player.addToBankroll(currentBet); }
    public void endGame() { }
    public void dealToPlayer(int amountOfCards) {
        for(int i =0; i < amountOfCards; i++) {
            this.playerHand.add(deck.draw());
        }
    }
    public void dealToDealer(int amountOfCards) {
        for(int i =0; i < amountOfCards; i++) {
            this.dealerHand.add(deck.draw());
        }
    }
    private void setCurrentBet(int bet) {
        this.currentBet = bet;
    }
    private  int getCardValue(Card card) {
        Rank rank = card.getRank();
        int calculateValue = 0;
        switch (rank) {
            case ACE:
                calculateValue = 1;
                break;
            case TWO:
                calculateValue = 2;
                break;
            case THREE:
                calculateValue = 3;
                break;
            case FOUR:
                calculateValue = 4;
                break;
            case FIVE:
                calculateValue = 5;
                break;
            case SIX:
                calculateValue = 6;
                break;
            case SEVEN:
                calculateValue = 7;
                break;
            case EIGHT:
                calculateValue = 8;
                break;
            case NINE:
                calculateValue = 9;
                break;
            case TEN:
            case JACK:
            case QUEEN:
            case KING:
                calculateValue = 0;
                break;
        }
        return calculateValue;
    }

    public void declareWinner() {

    }

    public int drawCard() {
        return 0;
    }

    public void stand() {

    }

    private int calculatehand(ArrayList<Card> hand) {
        int score = 0;
        for(int i = 0; i < hand.size(); i++) {
            score += getCardValue(hand.get(i));
        }
        if (score >= 10) {
            score = score - 10;
        }
        return score;
    }
    public void startGame() {
        start();
        while(playingBaccarat) {
            playerHand = new ArrayList<Card>();
            dealerHand = new ArrayList<Card>();
            Console.output("Welcome to Baccarat " + player.getName() + ". I will be your dealer.");
            int bet = Console.numberFromString(Console.askForInput("How much would you like to bet?"));
            setCurrentBet(bet);
            String betOn = Console.askForInput("Who do you want to bet on? (P/D)");
            dealToPlayer(2);
            dealToDealer(2);
            System.out.println("PH: " + Arrays.toString(this.playerHand.toArray(new Card[this.playerHand.size()])));
            System.out.println("DH: " + Arrays.toString(this.dealerHand.toArray(new Card[this.dealerHand.size()])));
            if(betOn.equals("p") && calculatehand(playerHand) == 9) {
                Console.output("You win!");
                player.addToBankroll(currentBet);
                currentBet = 0;
            } else if (betOn.equals("d") && calculatehand(dealerHand) == 9) {
                Console.output("You win!");
                player.addToBankroll(currentBet);
                currentBet = 0;
            } else {
                int playerHandAwayFromNine = Math.abs(calculatehand(playerHand) - 9);
                int dealerHandAwayFromNine = Math.abs(calculatehand(dealerHand) - 9);
                if ((betOn.equals("p") && playerHandAwayFromNine < dealerHandAwayFromNine) ||
                        (betOn.equals("d") && playerHandAwayFromNine > dealerHandAwayFromNine)) {
                    Console.output("You win!");
                    player.addToBankroll(currentBet);
                    currentBet = 0;
                } else {
                    Console.output("You lose");
                    player.subtractFromBankroll(currentBet);
                    currentBet = 0;
                }
            }
        }
    }
}