package io.zipcoder.casino;


import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class HighLowTest {

    Player player = new Player("Eug");
    HighLow game = new HighLow(player);

    @Test
    public void rollDice1(){
        int expected = 6;
        int actual = game.rollDice();
        assertEquals(expected, actual, 6);
    }

    @Test
    public void checkInput1() {
        String expected = null;
        String[] values = {"fghA", "fgh","dsf"};
        String actual = game.checkInput("zsdfe", values);
        assertEquals(expected, actual);
    }

    @Test
    public void checkInput2() {
        String expected = "7";
        String[] values = {"7", "6","7"};
        String actual = game.checkInput("7", values);
        assertEquals(expected, actual);
    }

    @Test
    public void checkInput3() {
        String expected = "h";
        String[] values = {"b", "h","f"};
        String actual = game.checkInput("H", values);
        assertEquals(expected, actual);
    }

    @Test
    public void checkInput4() {
        String expected = "fgha";
        String[] values = {"fghA", "fgh","dsf"};
        String actual = game.checkInput("FGhA", values);
        assertEquals(expected, actual);
    }

    @Test
    public void checkBankrupt1() {
        boolean expected = true;
        boolean actual = game.checkBankrupt();
        assertEquals(expected, actual);
    }

    @Test
    public void checkBankrupt2() {
        game.bet(500);
        boolean expected = true;
        boolean actual = game.checkBankrupt();
        assertEquals(expected, actual);
    }

    @Test
    public void checkBankrupt3() {
        game.bet(500);
        game.bet(500);
        //boolean expected = false;
        boolean actual = game.checkBankrupt();
        assertEquals(false, actual);
    }

    @Test
    public void checkBankrupt4() {
        game.bet(1000);
        boolean actual = game.checkBankrupt();
        assertEquals(false, actual);
    }

    @Test
    public void checkBankrupt5() {
        player.subtractFromBankroll(1000);
        boolean actual = game.checkBankrupt();
        assertEquals(false, actual);
    }

    @Test
    public void checkBankroll1() {
        boolean actual = game.checkBankroll(-900);
        assertEquals(false, actual);
    }

    @Test
    public void checkBankroll2() {
        boolean actual = game.checkBankroll(1100);
        assertEquals(false, actual);
    }

    @Test
    public void checkBankroll3() {
        boolean actual = game.checkBankroll(900);
        assertEquals(true, actual);
    }

    @Test
    public void checkIfInteger1() {
        boolean actual = game.checkIfInteger("90324");
        assertEquals(true, actual);
    }

    @Test
    public void checkIfInteger2() {
        boolean actual = game.checkIfInteger("90dfg24");
        assertEquals(false, actual);
    }



}
